/* $Id: crires_model_refining.h,v 1.18 2011-02-09 10:16:18 yjung Exp $
 *
 * This file is part of the CRIRES Pipeline
 * Copyright (C) 2002,2003 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: yjung $
 * $Date: 2011-02-09 10:16:18 $
 * $Revision: 1.18 $
 * $Name: not supported by cvs2svn $
 */

#ifndef CRIRES_MODEL_REFINING_H
#define CRIRES_MODEL_REFINING_H

/*-----------------------------------------------------------------------------
   								Includes
 -----------------------------------------------------------------------------*/

#include <cpl.h>
#include "crires_utils.h"
#include <crires_model_kernel.h>

/*-----------------------------------------------------------------------------
   							        Prototypes
 -----------------------------------------------------------------------------*/

double** crires_model_refining_custom_lines(const char*,
					    int,
					    const char*,
					    const char*,
					    const char*);
cpl_vector * crires_model_refining_extract(const cpl_image *,
                       crires_illum_period, 
					   cpl_vector *,
					   const char *,
					   const char *, 
					   const char *, 
					   int);
double** crires_model_refining_match(const cpl_vector **,
				     const cpl_vector **,
				     double**,
				     int,
				     int,
				     const char *);

cpl_table * crires_model_refining_fix(const cpl_vector *,
				      const cpl_vector *, 
				      const int *,
				      const cpl_vector *,
				      const char *,
				      const char *);

cpl_table * crires_model_refining_anneal(coord*, 
					 int,
					 double,
					 const char *,
					 const char *) ;

double** crires_model_refining_fibrefix(double**,
					const char*,
					const char*,
					int);

#endif
